﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.UI.Xaml.Charts;

namespace Funnel_and_Bubble
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void sampleChart_Loaded(object sender, RoutedEventArgs e)
        {          

            //Annotation with tooltip are used for representing the bubbles in the funnel chart.

            AnnotationCollection annotations = new AnnotationCollection()
            {            
                    new EllipseAnnotation()
                    {
                        CoordinateUnit = Syncfusion.UI.Xaml.Charts.CoordinateUnit.Pixel,
                         X1=250,
                         Y1=5,
                         X2=310,
                         Y2=65,
                         Stroke=new SolidColorBrush(Colors.Black), 
                         Fill=new SolidColorBrush(Color.FromArgb(0xFF, 0xA0, 0x50, 0x00)),
                         ToolTipContent = "Orange",
                         ShowToolTip = true,
                    },
                
                    new TextAnnotation()
                    {
                        CoordinateUnit= Syncfusion.UI.Xaml.Charts.CoordinateUnit.Pixel,
                        X1=273,
                        Y1=26,
                        Text="33",
                        Foreground=new SolidColorBrush(Colors.White) 
                    },
                                            

                    new EllipseAnnotation()
                    {
                        CoordinateUnit= Syncfusion.UI.Xaml.Charts.CoordinateUnit.Pixel,
                        X1=150, 
                        Y1=80, 
                        X2=210, 
                        Y2=140, 
                        Stroke=new SolidColorBrush(Colors.Black),
                        Fill=new SolidColorBrush(Color.FromArgb(0xFF, 0x1B, 0xA1, 0xE2)),
                           ToolTipContent = "Apple",
                         ShowToolTip = true,
                    },
                    
                    new TextAnnotation()
                    {
                        CoordinateUnit= Syncfusion.UI.Xaml.Charts.CoordinateUnit.Pixel, 
                        X1=173, 
                        Y1=103, 
                        Text="27",
                        Foreground=new SolidColorBrush(Colors.White)
                    },


                    new EllipseAnnotation()
                    { 
                        CoordinateUnit= Syncfusion.UI.Xaml.Charts.CoordinateUnit.Pixel,
                        X1=550,
                        Y1=80, 
                        X2=610, 
                        Y2=140, Stroke=new SolidColorBrush(Colors.Black), 
                        Fill=new SolidColorBrush(Color.FromArgb(0xFF, 0xD8, 0x00, 0x73)),
                           ToolTipContent = "Blueberry",
                         ShowToolTip = true,
                    },

                    new TextAnnotation()
                    {
                        CoordinateUnit= Syncfusion.UI.Xaml.Charts.CoordinateUnit.Pixel,
                        X1=575,
                        Y1=103,
                        Text="20",
                        Foreground=new SolidColorBrush(Colors.White) 
                    },
       

                    new EllipseAnnotation()
                    {
                        CoordinateUnit= Syncfusion.UI.Xaml.Charts.CoordinateUnit.Pixel,
                        X1=420, 
                        Y1=166, 
                        X2=450, 
                        Y2=196,
                        Stroke=new SolidColorBrush(Colors.Black), 
                        Fill=new SolidColorBrush(Color.FromArgb(0xFF, 0x33, 0x99, 0x33)),
                           ToolTipContent = "Grapes",
                         ShowToolTip = true,
                    },

                    new TextAnnotation()
                    {
                        CoordinateUnit= Syncfusion.UI.Xaml.Charts.CoordinateUnit.Pixel,
                        X1=428.5,
                        Y1=173,
                        Text="15",
                        Foreground= new SolidColorBrush(Colors.White) 
                    },
                    

                   new EllipseAnnotation()
                   {
                       CoordinateUnit= Syncfusion.UI.Xaml.Charts.CoordinateUnit.Pixel,
                       X1=410, 
                       Y1=282, 
                       X2=466, 
                       Y2=336, 
                       Stroke=new SolidColorBrush(Colors.Black), 
                       Fill=new SolidColorBrush(Color.FromArgb(0xFF, 0xA2, 0xC1, 0x39)),
                          ToolTipContent = "Banana",
                         ShowToolTip = true,
                   },
                                      
                   new TextAnnotation()
                   {
                       CoordinateUnit= Syncfusion.UI.Xaml.Charts.CoordinateUnit.Pixel, 
                       X1=435, 
                       Y1=301, 
                       Text="5",
                       Foreground=new SolidColorBrush(Colors.White) 
                   },
            };
            this.sampleChart.Annotations = annotations;
        }
    }

    public class ViewModel
    {
        ObservableCollection<Model> m_list;
        public ViewModel()
        {
            List = new ObservableCollection<Model>() 
            {
            new Model() { Category = "Iron", Percentage = 36 },
            new Model() {Category = "Zinc", Percentage = 32 },
            new Model() {Category = "Copper", Percentage = 34},
            new Model() {Category = "Aluminium", Percentage = 41 },
            new Model() {Category = "Gold", Percentage = 42 },
            new Model() {Category = "Silver", Percentage = 42 },
            new Model() {Category = "Diamond", Percentage = 43 },
            };        
        }
        public ObservableCollection<Model> List { get { return m_list; } set { m_list = value; } }
    }

    public class Model
    {
        string m_category;
        double m_percentage;

        public string Category { get { return m_category; } set { m_category = value; } }
        public double Percentage { get { return m_percentage; } set { m_percentage = value; } }
    }
}
